/*
var Settings = {
    "tabsSources":"listRadio",
    "radionomy":"1",

    "customText":"asdasdasdasd",
    "textNumberCustom":"http:\/\/streaming.hotmix-radio.net\/hotmixradio-hits-128.mp3",
    "imageCustom":"uploaded_data\/crop5628ad5da144a.png",

    "textRadionomy":"",
    "textNumberRadionomy":"",
    "imageRadionomy":"",
    "listRadio":
        [
            {
                "text":"asdasdasdasd",
                "textNumber":"http:\/\/streaming.hotmix-radio.net\/hotmixradio-hits-128.mp3",
                "imageList":"uploaded_data\/crop5628ad5da144a(2).jpg"
            },
            {
                "text":"asdasdasdasd",
                "textNumber":"http:\/\/streaming.hotmix-radio.net\/hotmixradio-hits-128.mp3",
                "imageList":"uploaded_data\/crop5628ad5da144a(3).png"
            }
        ],
    "name":"Enter your App name.","template":"newRadio","icon":"uploaded_data\/icon.png"
};
*/

var block = document.querySelector('#nonBlock'),
    tracks      = document.querySelector("#tracks"),
    radio = {0:{}};

if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '1'){
    radio[0]['textNumber'] = Settings.textNumberCustom;
    radio[0]['text'] = Settings.customText;
    radio[0]['image'] = Settings.imageCustom;

}else if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '2'){

    radio[0]['textNumber'] = 'http://listen.radionomy.com/'+Settings.textNumberRadionomy.replace(/(https\:\/\/www\.radionomy\.com\/en\/radio\/)/, '').replace(/\/index/,'');
    radio[0]['text'] = Settings.textRadionomy;
    radio[0]['image'] = Settings.imageRadionomy;

}else{
    radio = Settings.listRadio;
}
if(radio[0].customText == ''){
    block.style.display = 'block';
}else if(radio[0].text == ''){
    block.style.display = 'block';
}


var play  = document.querySelector("#play"),
    prev  = document.querySelector("#prev"),
    next  = document.querySelector("#next"),

// - Time
    elapsedTime   = document.querySelector("#elapsedtime"),
    totalTime     = document.querySelector("#totaltime"),
    progressBar   = document.querySelector("#progressbar"),
    audioControls = document.querySelector("#controls"),

// - UI elements
    audio       = document.querySelector("#mytrack"),
    loader     = document.querySelector("#run-loader"),
    artwork     = document.querySelector("#artwork"),
    background  = document.querySelector("#background"),
    i  = document.querySelector("i.small"),

// - Interval
    timer,

// - Tracks
    defaultTrack    = 1,
    currentTrack    = defaultTrack,
    playlist        = [],

// - Audio
    duration,
    audioState      = "pause",

// - Auto
    autoPlay        = true,
    autoRepeat      = true;
window.pause = '';
parsSettings();


function parsSettings(){
    for(var i = 0; i < radio.length; i++){
        if(radio[i].textNumber.substr(radio[i].textNumber.length-3,3).toLowerCase() == 'm3u'){
            getStream(radio[i].textNumber,i);
        }
    }
}


// - Audio Controls
function getStream(src,i) {
    $.get(src, function(res) {
        radio[i].textNumber = res.responseText.split('&#xd;')[1].replace(/<\/?[^>]+>/g,'').replace(/\n/g,'');
    });
}



window.playAudio = function()
{

    var src = radio[currentTrack-1].textNumber,
        icon = 'mdi-av-pause small';
    if (typeof AudioPlayer == 'undefined') {
        audio.play(); // Play
        pause = 'true';
    }else{
        AudioPlayer.play(audio.src);
    }
    loader.style.display = 'block';
    audioState = "play";
    changeBackgroundImage(play, icon);
}
function hideLoader() {
    loader.style.display = "none";
}
if (typeof AudioPlayer == 'undefined') {
    audio.addEventListener('playing',function() { hideLoader(); },false);
}else{
    AudioPlayer.setOnLoadListener("hideLoader");
    AudioPlayer.setOnTrackFinishedListener("playAudio");
}



// - Control's functions
function pauseAudio()
{

    var icon = 'mdi-av-play-arrow small';
    if (typeof AudioPlayer == 'undefined') {
        audio.pause();
    }else{
        AudioPlayer.pause();
    }
    loader.style.display = "none";
    audioState = "pause";

    changeBackgroundImage(play, icon);

    clearInterval(timer);
}

function stopAudio()
{

    if (typeof AudioPlayer == 'undefined') {
        audio.currentTime = 0;
    }else{
        AudioPlayer.stop();
    }
    clearInterval(timer);
}


function updateActiveTrack(num)
{
    tracks.children[num-1].classList.add("active");
}

// Chamge audio tag song
function changeSong(num)
{

    currentTrack  = parseInt(num);
    var artworkSrc, src  = radio[currentTrack-1].textNumber;
    // Delete CSS classes to all tracks
    for(var i = 0; i < playlist.length; i++) {
        tracks.children[i].removeAttribute("class");
    }
    if(radio[currentTrack-1].image == undefined){
        artworkSrc    = radio[currentTrack-1].imageList;
    }else{
        artworkSrc    = radio[currentTrack-1].image;
    }
    console.log(src);
    artwork.src   = artworkSrc;
    audio.src     = src;

    updateActiveTrack(currentTrack);
    changeBackgroundImage(artwork, artworkSrc);
    if(audioState === "play") {
        loader.style.display = "none";
        playAudio();
    }
}


// - TIME
function getAudioSeconds(string)
{
    var seconds = string % 60;
    seconds = addZero( Math.floor(seconds), 2 );

    if(seconds < 60) { return seconds; } else { return "00"; }
}

function getAudioMinutes(string)
{
    var minutes = string / 60;
    minutes = addZero( Math.floor(minutes), 2 );

    if(minutes < 60) { return minutes; } else { return "00"; }
}

// - FIX ZERO - Nice functions i made, i think sharing will it helps

// Add howManyZero to from the begin
function addZero(word, howManyZero)
{
    var word = String(word);

    while(word.length < howManyZero) { word = "0" + word; }

    return word;
}

// - Remove howManyZero from the begin
function removeZero(word, howManyZero)
{
    var word  = String(word),
        i     = 0;

    while(i < howManyZero)
    {
        if(word[0] === "0") { word = word.substr(1, word.length); } else { break; }

        i++;
    }

    return word;
}

// - Manage DOM Nodes
function insertDOMElement(parent, htmlString)
{
    parent.insertAdjacentHTML("beforeend", htmlString);
}

function createTrackItem(trackNum, trackTitle, trackArtist, trackImage)
{

    var div = "";
    if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '1'){
        div += "<p>" + trackTitle + "</p>";
    }else if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '2'){
        div += "<p>" + trackTitle + "</p>";
    }else{
        div += "<artwork style='background-image: url(\"" + trackImage + "\")'></artwork>";
        div += "<span>" + trackNum + ". " + trackArtist + "</span>";
    }

    return div;
}

function populateTrack()
{
    var children, trackName, trackArtist, trackartwork, obj, img;

    if(Settings.radionomy == 1){
        img = radio[0].imageCustom;
    }else{
        img = radio[0].imageRadionomy;
    }
    if(radio.length == undefined){
        for(var i = 0; i < tracks.children.length; i++)
        {

            children      = tracks.children[i],
                trackName     = children.getAttribute("trackname"),
                trackArtist   = children.getAttribute("trackartist"),
                trackartwork  = children.getAttribute("trackartwork"),
                obj           = {
                    title: trackName,
                    artist: trackArtist,
                    artwork: trackartwork
                };

            playlist.push(obj);
            insertDOMElement(
                children,
                createTrackItem(
                    addZero((i+1) ,2),
                    playlist[i].title,
                    playlist[i].artist,
                    img
                )
            );

            children.removeAttribute("trackname");
            children.removeAttribute("trackartist");
            children.removeAttribute("trackartwork");

            children.setAttribute("tracknum", i+1);
        }
    }else{
        for(var i = 0; i < tracks.children.length; i++)
        {

            children      = tracks.children[i],
                trackName     = children.getAttribute("trackname"),
                trackArtist   = children.getAttribute("trackartist"),
                trackartwork  = children.getAttribute("trackartwork"),
                obj           = {
                    title: trackName,
                    artist: trackArtist,
                    artwork: trackartwork
                };

            playlist.push(obj);
            insertDOMElement(
                children,
                createTrackItem(
                    addZero((i+1) ,2),
                    playlist[i].title,
                    playlist[i].artist,
                    radio[i].imageList
                )
            );

            children.removeAttribute("trackname");
            children.removeAttribute("trackartist");
            children.removeAttribute("trackartwork");

            children.setAttribute("tracknum", i+1);
        }
    }

}

// - DOM Animation / Styles / Updates
function changeBackgroundImage(element, image)
{
    if(element.getAttribute('id') == 'play'){
        var firstElem = element.firstElementChild;
        firstElem.className = image;
    }else{
        var new_img = new Image();

        new_img.onload = function() {
            var img_width  = this.width,
                img_heigth = this.height;
            if(img_width <= 150){
                element.style.backgroundSize = '30%';
                element.firstElementChild.innerHTML = 'asdasds';
            }
        };
        new_img.src = image;
        element.style.backgroundImage = "url('" + image + "')";
        element.style.backgroundSize = '100%';
        element.firstElementChild.innerHTML = '';
    }
}

function updateProgressBarPosition()
{
    var percentage  = (audio.currentTime * 100 / duration) + "%",
        children    = progressBar.children[0];

    children.style.width = percentage;
}

function updateTime()
{
    var audioTime = getAudioMinutes(audio.currentTime) + ":" + getAudioSeconds(audio.currentTime);

    updateProgressBarPosition();
    elapsedTime.innerHTML = audioTime;

    if(audio.ended)
    {
        if(currentTrack === (playlist.length))
        {
            currentTrack = defaultTrack;
            changeSong(currentTrack);
        }
        else
        {
            currentTrack = currentTrack + 1;
            changeSong(currentTrack);
        }

        if(autoRepeat) { playAudio(); }

    }
}

var idtrack = document.getElementById('tracks');
var player = document.getElementById('player');
var ui = document.getElementById('ui');

var colorBut,
    afterColorBut;
if(Settings.colorBut == '' || Settings.colorBut == undefined){colorBut = 'black';}else{colorBut = '#'+Settings.colorBut;}
if(Settings.backColor == '' || Settings.backColor == undefined){backColor = '#E0E0E0';}else{backColor = '#'+Settings.backColor;}
if(Settings.curButton == '' || Settings.curButton == undefined){curButton = '#ef5350';}else{curButton = '#'+Settings.curButton;}
// - EVENTS
window.onload = function() {
    changeSong(defaultTrack);
    loader.style.display = 'none';
    if(Settings.tabsSources == 'myradio'){
        var new_img = new Image();

        new_img.onload = function() {
            var img_width  = this.width,
                img_heigth = this.height;
            console.log(img_width);
            if(img_width <= 150){
                artwork.style.width = img_width+'px';
                artwork.style.height = img_heigth+'px';
                artwork.style.padding = 0;
                artwork.style.float = 'left';
                idtrack.style.float = 'left';
                idtrack.style.width = player.clientWidth - img_width+'px';
                idtrack.firstElementChild.style.height = img_heigth+'px';
            }
        };
        new_img.src = artwork.src;
    }

    if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '1'){
        ui.style.bottom = "-30px";
        tracks.firstElementChild.style.backgroundColor = 'transparent';
        controls.style.backgroundColor = 'transparent';
        prev.style.display = 'none';
        next.style.display = 'none';
        play.style.width = '100%';
        play.style.marginBottom = '25%';
        play.firstElementChild.style.backgroundColor = curButton;
        play.firstElementChild.style.color = '#fff';
        play.firstElementChild.style.borderRadius = '50%';
        play.firstElementChild.style.fontSize = '1.5rem';
        play.firstElementChild.style.padding = '25px';
        $('#ui #controls').css({
            backgroundColor: 'transparent'
        });
    }else if(Settings.tabsSources == 'myRadio' && Settings.radionomy == '2'){
        ui.style.bottom = "-30px";
        tracks.firstElementChild.style.backgroundColor = 'transparent';
        controls.style.backgroundColor = 'transparent';
        prev.style.display = 'none';
        next.style.display = 'none';
        play.style.width = '100%';
        play.style.marginBottom = '25%';
        play.firstElementChild.style.backgroundColor = curButton;
        play.firstElementChild.style.color = '#fff';
        play.firstElementChild.style.borderRadius = '50%';
        play.firstElementChild.style.fontSize = '1.5rem';
        play.firstElementChild.style.padding = '25px';
        $('#ui #controls').css({
            backgroundColor: 'transparent'
        });
    }else{
        $('#ui #controls').css({
            backgroundColor: backColor
        });
    }
    $('i.small').css({
        color: colorBut
    });
    //i.style.color = colorBut;
};


var tack = '';
if(radio.length == undefined){
    tack += "<div trackartist='"+radio[0].text+"' trackname='"+radio[0].text+"' trackartwork=''></div>";
}else{
    for(var i = 0;i < radio.length;i ++){
        tack += "<div trackartist='"+radio[i].text+"' trackname='"+radio[i].text+"' trackartwork=''></div>";
    }
}
idtrack.innerHTML = tack;

// - POPULATE HTML
populateTrack();

audio.addEventListener(
    'loadedmetadata',
    function()
    {
        var time = getAudioMinutes(duration) + ":" + getAudioSeconds(duration);

        duration            = audio.duration;
        totalTime.innerHTML = time;

    }
);

play.addEventListener(
    "click",
    function()
    {
        if(audioState === "pause")
        {
            playAudio();
            updateActiveTrack( currentTrack );
        }
        else if(audioState === "play") { pauseAudio(); }
    }
);

prev.addEventListener(
    "click",
    function()
    {
        if(currentTrack > 1)
        {
            stopAudio();
            changeSong(currentTrack - 1);
        }
        else if(currentTrack === 1)
        {
            stopAudio();
            changeSong(currentTrack);
        }
    }
);

next.addEventListener(
    "click",
    function()
    {
        if(currentTrack < playlist.length)
        {
            stopAudio();
            updateTime();
            changeSong(currentTrack + 1);
        }
        else
        {
            currentTrack = 1;
            changeSong(currentTrack);
        }
    }
);

progressBar.addEventListener(
    "click",
    function(e)
    {
        var mouseX,
            percentage,
            newTime;

        if(e.offsetX){ mouseX = e.offsetX; }
        if(mouseX == undefined && e.layerX) { mouseX = e.layerX; }

        percentage  = mouseX / progressBar.offsetWidth;
        newTime     = audio.duration * percentage;

        audio.currentTime = newTime;

        updateProgressBarPosition();
    }
);

// - Add events to all tracks
for(var i = 0; i < playlist.length; i++)
{

    tracks.children[i].addEventListener(
        "click",
        function()
        {
            var btn       = this,
                trackNum  = parseInt(btn.getAttribute("tracknum"));

            if(btn.classList[0] !== "active")
            {
                tracks.children[1].removeAttribute("class");
                btn.classList.add("active");
                changeSong(trackNum);
            }
        }
    );

}
// - Add events to all audioControls
for(var i = 0; i < audioControls.children.length; i++)
{

    audioControls.children[i].addEventListener(
        "mousedown",
        function()
        {

            var btn   = this,
                icon  = '';


            if(btn.id == 'play'){
                icon = 'mdi-av-play-arrow small';
            }else if(btn.id == 'pause'){
                icon = 'mdi-av-pause small';
            }
            btn.firstElementChild.style.color = 'white';
            changeBackgroundImage( btn, icon );

            if(btn.classList[0] !== "shadow")
            {
                for(var x = 0; x < audioControls.children.length; x++)
                {
                    audioControls.children[x].classList.remove("shadow");
                }
            }
        }
    );

    audioControls.children[i].addEventListener(
        "mouseup",
        function()
        {
            var btn   = this,
                icon  = '';
            if(btn.id == 'play'){
                icon = 'mdi-av-play-arrow small';
            }else if(btn.id == 'pause'){
                icon = 'mdi-av-pause small';
            }
            btn.firstElementChild.style.color = colorBut;
            changeBackgroundImage( btn, icon );
        }
    );

}