// TODO исправить INDEXOF in onPageBeforeInt and onPageAfterBack

'use strict';

var $$ = Dom7;
var intervalID;
var myList;
var array_photos = [];
var myPhotoBrowserPopupDark = [];
// Loading flag
var loading = false;

// Init App
window.myApp = new Framework7({
    init: false,
    material: true,
    pushState: true,
    domCache: true,
    swipePanel: 'right',
    modalButtonFacebookOk: 'Log with Facebook',
    onPageBeforeInit: function (page) {
    },
    onPageAfterBack: function (page) {
        console.log(page.mainView.url);
    },
    tapHold: true
});

window.mainView = myApp.addView('.view-main', {});

myApp.onPageInit('index', function (page) {

    var docReady = $.Deferred();
    var facebookReady = $.Deferred();
    FB.init({
        appId: 1715130832037855,
        xfbml: true,
        status: true,
        version: 'v2.5'
    });
    facebookReady.resolve();
    App.init();

    $(function () {

        var container = $$('.page-content.main.infinite-scroll');
        var cover = 266 - 56;
        //mover scroll posicion, duracion
        container.scroll(function () {
            var top = container.offset().top;
            var str = (top) / cover;
            $$('[data-page="index"] .navbar').css('background-color', convertHex(Settings.themeColors.colorPrimary, str));
        });
    });

    $(document).ready(docReady.resolve);

    window.app = {
        auth: getAuth(),
        me: getInfo(),
        token: getToken()
    };
    if (AppsgeyserJSInterface.getItem('log_in') === 'true') {
        myApp.alert('<p style="text-align: center;">Congratulations!</p>You have successfully logged in. Now you can like and comment posts, view videos and download images.', '');
        AppsgeyserJSInterface.setItem('log_in', false);
        $('#log-in').parent().hide();
    } else {
        if(AppsgeyserJSInterface.getItem('log_in') === 'false') {
            $('#log-in').parent().hide();
        }
    }

    window.mainSwiper = myApp.swiper('.main-content', {
        hashnav: true
    });
    $$('.share-groups').on('click', function () {
        window.location.href = 'https://www.facebook.com/sharer.php?u=' + encodeURIComponent('https://www.facebook.com/' + inputString);
    });

    $$('.save-groups').on('click', function () {
        if (window.app.me) {
            var save_group = localStore.jStorage.get(inputString + '_save_group');
            if (save_group) {
                localStore.jStorage.deleteKey(inputString + '_save_group');
                $$(this).removeClass('active_save_group');
            } else {
                localStore.jStorage.set(inputString + '_save_group', true);
                $$(this).addClass('active_save_group');
            }
        } else {
            errorMessage({
                error: {
                    code: 200,
                    message: "(#200) You do not have sufficient permissions to perform this action"
                }
            })
        }
    });


    $$(document).on('infinite', '.main.infinite-scroll', function (e) {
        // Exit, if loading in progress
        if (loading) return;

        // Set loading flag
        loading = true;

        if (window.app.auth) {
            myApp.showIndicator();
            setTimeout(function () {
                loading = false;
                post.updatePost(function (data) {
                    for (var i = 0; i < data.length; i++) $$('#list-post, .posts-group').append(data[i]);
                    myApp.hideIndicator();
                });
            }, 1000);
        } else {
            errorMessage({
                error: {
                    code: 200,
                    message: "(#200) You do not have sufficient permissions to perform this action"
                }
            })
        }
    });

});

myApp.onPageInit('albums', function (page) {
    $$($$(page.container).find('.navbar')).css('background-color', convertHex(Settings.themeColors.colorPrimary, 1));
    photo.getAlbums();
});

myApp.onPageInit('settings', function (page) {
    $$($$(page.container).find('.navbar')).css('background-color', convertHex(Settings.themeColors.colorPrimary, 1));
    console.log(page);
});


myApp.onPageInit('album', function (page) {
    var json = JSON.parse(window.location.hash.replace(/.*#json\=/g, ''));
    var photos = [];
    var album, deferreds = {}, listOfDeferreds = [];
    $$(page.container).find('#title').html(json.name);

    deferreds[json.id] = jQuery.Deferred();

    listOfDeferreds.push(deferreds[json.id]);

    $$($$(page.container).find('.navbar')).css('background-color', convertHex(Settings.themeColors.colorPrimary, 1));

    FB.api(
        '/' + json.id + '/',
        {fields: 'photos.limit(50)', access_token: window.app.token},
        function (albumPhotosResponse) {
            console.log(albumPhotosResponse);
            if (albumPhotosResponse && !albumPhotosResponse.error) {
                localStore.jStorage.set('after_photos', (albumPhotosResponse.photos.paging.next) ? albumPhotosResponse.photos.paging.next : null);
                var i, facebookPhoto;
                for (i = 0; i < albumPhotosResponse.photos.data.length; i++) {
                    facebookPhoto = albumPhotosResponse.photos.data[i];
                    photos.push({
                        'id': facebookPhoto.id,
                        'added': facebookPhoto.created_time,
                        'caption': facebookPhoto.name,
                        'created_time': getTime(facebookPhoto.created_time),
                        'timestamp': new Date(facebookPhoto.created_time).getTime(),
                        'url_t': makeFacebookPhotoURL(facebookPhoto.id, 'thumbnail'),
                        'url_a': makeFacebookPhotoURL(facebookPhoto.id, 'album'),
                        'url': makeFacebookPhotoURL(facebookPhoto.id, 'normal'),
                        'like': 8
                    });
                }
                deferreds[json.id].resolve();
            } else {
                errorMessage({
                    error: {
                        code: 200,
                        message: "(#200) You do not have sufficient permissions to perform this action"
                    }
                })
            }
        }
    );


    jQuery.when.apply(jQuery, listOfDeferreds).then(function () {
        addPhotosAlbum(photos);
    }, function (error) {
    });


    $$(document).on('infinite', '.photo.infinite-scroll', function (e) {
        // Exit, if loading in progress
        if (loading) return;

        // Set loading flag
        loading = true;
        var url = localStore.jStorage.get('after_photos');

        if (url !== null) {
            myApp.showIndicator();
            if (window.app.auth) {
                setTimeout(function () {
                    loading = false;
                    var photos = [];
                    var album, deferreds = {}, listOfDeferreds = [];


                    deferreds[json.id] = jQuery.Deferred();

                    listOfDeferreds.push(deferreds[json.id]);
                    FB.api(
                        url,
                        {fields: 'photos.limit(50)', access_token: window.app.token},
                        function (albumPhotosResponse) {
                            //if (callback) callback(albumId, albumPhotosResponse);
                            localStore.jStorage.set('after_photos', (albumPhotosResponse.paging.next) ? albumPhotosResponse.paging.next : null);
                            var i, facebookPhoto;
                            for (i = 0; i < albumPhotosResponse.data.length; i++) {
                                facebookPhoto = albumPhotosResponse.data[i];
                                photos.push({
                                    'id': facebookPhoto.id,
                                    'added': facebookPhoto.created_time,
                                    'caption': facebookPhoto.name,
                                    'created_time': getTime(facebookPhoto.created_time),
                                    'timestamp': new Date(facebookPhoto.created_time).getTime(),
                                    'url_t': makeFacebookPhotoURL(facebookPhoto.id, 'thumbnail'),
                                    'url_a': makeFacebookPhotoURL(facebookPhoto.id, 'album'),
                                    'url': makeFacebookPhotoURL(facebookPhoto.id, 'normal'),
                                    'like': 8
                                });
                            }
                            deferreds[json.id].resolve();

                            jQuery.when.apply(jQuery, listOfDeferreds).then(function () {
                                addPhotosAlbum(photos);
                            }, function (error) {
                            });
                        }
                    );
                }, 1000);

            } else {
                errorMessage({
                    error: {
                        code: 200,
                        message: "(#200) You do not have sufficient permissions to perform this action"
                    }
                })
            }
        } else {
            // Nothing more to load, detach infinite scroll events to prevent unnecessary loadings
            myApp.hideIndicator();
            myApp.addNotification({
                title: '',
                message: 'No more photos'
            });
            $$('.notifications .button.close-notification').hide();
            setTimeout(function () {
                $$('.notifications .button.close-notification').click();
            }, 2000);
        }
    });
});

myApp.onPageInit('about', function (page) {
    $$($$(page.container).find('.navbar')).css('background-color', convertHex(Settings.themeColors.colorPrimary, 1));

    var $$location = $$('.location');
    var $$genre = $$('.genre');
    var $$gen_m = $$('.gen_m');

    var $$about = $$('.about, .about-content p');
    FB.api(
        '/' + inputString,
        {
            fields: 'id,description,is_verified,about,cover,photos{album},category,username,name,fan_count,current_location,genre,general_manager',
            access_token: window.app.token
        },
        function (data) {

            if (data && !data.error) {

                $$about.html(data.about);

                $$location.html(data.current_location);

                $$genre.html(data.genre);

                $$gen_m.html(data.general_manager);

            } else {
                console.log(data);
                errorMessage(data);
            }
        }
    );
});

myApp.onPageInit('post', function (page) {
    $$($$(page.container).find('.navbar')).css('background-color', convertHex(Settings.themeColors.colorPrimary, 1));
    var id = window.location.hash.replace(/.*#id\=/g, '');
    var myMessagebar = myApp.messagebar('.messagebar', {
        maxHeight: 200
    });
    intervalID = setInterval(function () {
        if ($$('#small-img').html() == undefined || $$('#small-img').html() == '') {
            loadPostInterval(false, id, page);
        } else {
            clearInterval(intervalID);
            loadPostInterval(true, id, page);
        }
    }, 1000);


    $$('.infinite-scroll-preloader').css('height', $$('body').height() - 50 + 'px');

    // Add 'refresh' listener on it
    $$(document).on('refresh', '.pull-to-refresh-content', function (e) {
        $$('.list-block-comments').html('');
        loadPostInterval(true, id, page);
    });


    $$(document).on('taphold', '.item-content', function () {
        var clickedLink = this;
        var me = localStore.jStorage.get('me');
        var delete_button = ($$(clickedLink).find('.comments-title').html() === me.name) ?
        '<li><a href="#" class="item-link list-button delete-comments-post" data-id="' + $$(clickedLink).attr('id') + '">Delete</li>' : '';

        var popoverHTML = '<div class="popover">' +
            '<div class="popover-inner">' +
            '<div class="list-block">' +
            '<ul style="margin-bottom: 0;">' +
            '' + delete_button + '' +
            '<li><a href="#" class="item-link list-button cancel-popover">Cancel</li>' +
            '</ul>' +
            '</div>' +
            '</div>' +
            '</div>';
        myApp.popover(popoverHTML, clickedLink);
    });

    $$(document).on('click', '.cancel-popover', function () {
        myApp.closeModal('.popover');
    });

    $$(document).on('click', '.delete-comments-post', function () {
        myApp.showIndicator();
        var id = $$(this).dataset().id;
        FB.api(
            "/" + id,
            "DELETE",
            {access_token: window.app.token},
            function (response) {
                if (response && !response.error) {
                    myApp.hideIndicator();
                    $$('#'+id).remove();
                    myApp.closeModal('.popover');
                } else {
                    errorMessage(response);
                }
            }
        );
    });

    $$('.messagebar .link').on('click', function () {
        myApp.showIndicator();

        // Message text
        var messageText = myMessagebar.value().trim();

        // Exit if empy message
        if (messageText.length === 0) return;


        var id = window.location.hash.replace(/.*#id\=/g, '').replace(/.*\_/g, '');
        console.log(id);
        if (window.app.me != null) {
            FB.api(
                "/"+id+"/comments",
                "POST",
                {
                    "message": messageText,
                    access_token: window.app.token
                },
                function (response) {
                    if (response && !response.error) {
                        myApp.addNotification({message: 'Refresh this page', button: {text: 'Ok', color: 'yellow'}});

                        setTimeout(function () {
                            $$('.close-notification').click();
                        }, 5000);
                        myApp.hideIndicator();
                    } else {
                        myApp.hideIndicator();
                        errorMessage(response);
                    }
                }
            );
            myMessagebar.value('');
        }
    });

    $$(document).on('infinite', '.post.infinite-scroll', function () {
        myApp.showIndicator();
        // Exit, if loading in progress
        if (loading) return;

        // Set loading flag
        loading = true;

        // Emulate 1s loading
        setTimeout(function () {
            // Reset loading flag
            loading = false;
            comments.updateCommentsPost(id);
        }, 1000);
    });
});

$$(document).on('click', '.main-album', function () {
    var json = $(this).data('json');
    mainView.router.loadPage('album.html#json=' + JSON.stringify(json));
});

$$(document).on('click', '.play', function(){
    mainView.router.loadPage('video.html#id=' + $(this).data('id'));
});

$('.log_in').on('click', function(){
    authFB();
});

$('.log_out').on('click', function(){
    AppsgeyserJSInterface.setItem('auth', false);
    AppsgeyserJSInterface.setItem('token', null);
    localStore.jStorage.get('me', false);
    location.reload();
});

$$(document).on('click', '.sh-f', function(){
    var url = $(this).data('url');
    if (('AppsgeyserJSInterface' in window)) {
        AppsgeyserJSInterface.setItem('url', window.location.href);
        window.location.href = url;
    }
});
myApp.init();
